/**!
   * mongodash v1.4.0
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2022 Václav Oborník
   * Released under the MIT license
   */
  "use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.secureOnError = exports.defaultOnError = void 0;
const defaultOnError = (error) => {
    console.error(error);
};
exports.defaultOnError = defaultOnError;
function secureOnError(onError) {
    return (error) => {
        try {
            onError(error);
        }
        catch (onErrorFailure) {
            // intentionally suppress
        }
    };
}
exports.secureOnError = secureOnError;
//# sourceMappingURL=OnError.js.map