/**!
   * mongodash v1.4.0
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2022 Václav Oborník
   * Released under the MIT license
   */
  "use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = exports.withTransaction = exports.LockAlreadyAcquiredError = exports.isLockAlreadyAcquiredError = exports.withLock = exports.getMongoClient = exports.getCollection = exports.CODE_CRON_TASK_FAILED = exports.CODE_CRON_TASK_SCHEDULED = exports.CODE_CRON_TASK_FINISHED = exports.CODE_CRON_TASK_STARTED = exports.stopCronTasks = exports.startCronTasks = exports.scheduleCronTaskImmediately = exports.runCronTask = exports.cronTask = void 0;
const cronTasks_1 = require("./cronTasks");
const getCollection_1 = require("./getCollection");
const getMongoClient_1 = require("./getMongoClient");
const OnError_1 = require("./OnError");
const OnInfo_1 = require("./OnInfo");
const withLock_1 = require("./withLock");
const initPromise_1 = require("./initPromise");
var cronTasks_2 = require("./cronTasks");
Object.defineProperty(exports, "cronTask", { enumerable: true, get: function () { return cronTasks_2.cronTask; } });
Object.defineProperty(exports, "runCronTask", { enumerable: true, get: function () { return cronTasks_2.runCronTask; } });
Object.defineProperty(exports, "scheduleCronTaskImmediately", { enumerable: true, get: function () { return cronTasks_2.scheduleCronTaskImmediately; } });
Object.defineProperty(exports, "startCronTasks", { enumerable: true, get: function () { return cronTasks_2.startCronTasks; } });
Object.defineProperty(exports, "stopCronTasks", { enumerable: true, get: function () { return cronTasks_2.stopCronTasks; } });
Object.defineProperty(exports, "CODE_CRON_TASK_STARTED", { enumerable: true, get: function () { return cronTasks_2.CODE_CRON_TASK_STARTED; } });
Object.defineProperty(exports, "CODE_CRON_TASK_FINISHED", { enumerable: true, get: function () { return cronTasks_2.CODE_CRON_TASK_FINISHED; } });
Object.defineProperty(exports, "CODE_CRON_TASK_SCHEDULED", { enumerable: true, get: function () { return cronTasks_2.CODE_CRON_TASK_SCHEDULED; } });
Object.defineProperty(exports, "CODE_CRON_TASK_FAILED", { enumerable: true, get: function () { return cronTasks_2.CODE_CRON_TASK_FAILED; } });
var getCollection_2 = require("./getCollection");
Object.defineProperty(exports, "getCollection", { enumerable: true, get: function () { return getCollection_2.getCollection; } });
var getMongoClient_2 = require("./getMongoClient");
Object.defineProperty(exports, "getMongoClient", { enumerable: true, get: function () { return getMongoClient_2.getMongoClient; } });
var withLock_2 = require("./withLock");
Object.defineProperty(exports, "withLock", { enumerable: true, get: function () { return withLock_2.withLock; } });
Object.defineProperty(exports, "isLockAlreadyAcquiredError", { enumerable: true, get: function () { return withLock_2.isLockAlreadyAcquiredError; } });
Object.defineProperty(exports, "LockAlreadyAcquiredError", { enumerable: true, get: function () { return withLock_2.LockAlreadyAcquiredError; } });
var withTransaction_1 = require("./withTransaction");
Object.defineProperty(exports, "withTransaction", { enumerable: true, get: function () { return withTransaction_1.withTransaction; } });
let initCalled = false;
async function init(options) {
    var _a, _b, _c, _d, _e;
    if (initCalled) {
        throw new Error('init method can be called only once.');
    }
    initCalled = true;
    const onError = options.onError ? (0, OnError_1.secureOnError)(options.onError) : OnError_1.defaultOnError;
    const onInfo = options.onInfo ? (0, OnInfo_1.secureOnInfo)(options.onInfo) : OnInfo_1.defaultOnInfo;
    (0, getCollection_1.init)({ collectionFactory: (_a = options.collectionFactory) !== null && _a !== void 0 ? _a : null });
    (0, withLock_1.init)({ onError });
    (0, cronTasks_1.init)({
        runCronTasks: (_b = options.runCronTasks) !== null && _b !== void 0 ? _b : true,
        cronExpressionParserOptions: (_c = options.cronExpressionParserOptions) !== null && _c !== void 0 ? _c : {},
        onError,
        onInfo,
        cronTaskCaller: (_d = options.cronTaskCaller) !== null && _d !== void 0 ? _d : ((task) => task()),
    });
    await (0, getMongoClient_1.init)(Object.assign(Object.assign({}, options), { autoConnect: (_e = options.autoConnect) !== null && _e !== void 0 ? _e : true }));
    (0, initPromise_1.resolveInitPromise)();
}
exports.init = init;
//# sourceMappingURL=index.js.map