import { InitOptions as CronTasksInitOptions } from './cronTasks';
import { InitOptions as GetCollectionInitOptions } from './getCollection';
import { InitOptions as GetMongoClientInitOptions } from './getMongoClient';
import { OnError } from './OnError';
import { OnInfo } from './OnInfo';
export { cronTask, Interval, runCronTask, scheduleCronTaskImmediately, startCronTasks, stopCronTasks, TaskFunction, TaskId, CODE_CRON_TASK_STARTED, CODE_CRON_TASK_FINISHED, CODE_CRON_TASK_SCHEDULED, CODE_CRON_TASK_FAILED, } from './cronTasks';
export { getCollection } from './getCollection';
export { getMongoClient } from './getMongoClient';
export { OnError } from './OnError';
export { withLock, isLockAlreadyAcquiredError, WithLockOptions, LockAlreadyAcquiredError } from './withLock';
export { withTransaction } from './withTransaction';
declare type PackageOptions = {
    onError?: OnError;
    onInfo?: OnInfo;
};
export declare type InitOptions = PackageOptions & GetMongoClientInitOptions & Partial<CronTasksInitOptions> & Partial<GetCollectionInitOptions>;
export declare function init(options: InitOptions): Promise<void>;
